<?php

Class ArticleAction extends PublicAction {

	// 查看分类文章
        public function category() {
            $id = $_REQUEST["id"];
            if (!empty($id)) {
                $CateList = M("Category");
                if ($CateList) {
                    $categoryName = $CateList->where('id='.$id)->getField("title");
                    $this->assign('categoryName', $categoryName);
                    $dao = D('ArticleView');
                    //导入分页类
                    import("@.ORG.Page");
                    //取得满足条件的记录数
                    $count = $dao->where('status=1')->where('categoryId='.$id)->count();
                    $p = new Page($count, 5);
                    //分页查询数据
                    $voList = $dao->where('status=1')->where('categoryId='.$id)->limit($p->firstRow.','.$p->listRows)->select();
                    //分页显示
                    $page = $p->show();
                    //模板赋值显示

                    $this->assign('list', $voList);
                    $this->assign("count", $count);
                    $this->assign("page", $page);
                }else {
                   $this->redirect('index');
                   return ;
                }
                
            }else {
                $this->redirect('index');
            }
            
            $this->display();
            return ;
        }

        public function show() {
            $this->getComment();
            $this->getAttach();
            $id = $_REQUEST["id"];
            if (!empty($id)) {
               $Article = D("ArticleView");
               $result = $Article->where('Article.id='.$id)->find();  // 这里为什么用select()就读不出来
               if ($result) {
                   $this->assign('voshow', $result);
               }else {
                   $this->redirect('index');
                   return ;
               }
            }else {
                $this->redirect('index');
            }
            $this->display();
            return ;
        }

        public function _after_show() {
            $Article = D("Article");
            $article = $this->get('voshow');
            // 阅读计数
            $id	= $article["id"];
            if(!isset($_SESSION['article_read_count_'.$id])) {
		$Article->setInc('readCount',"id=".$id);
		$_SESSION['article_read_count_'.$id] = true;
            }
        }

	public function index() {
	
                       
                    //切换到高级模型
            $Article = M("Article", "AdvModel");
            $Comment = M("Comment", "AdvModel");
             // 需要将msubstr()从扩展库extend.php中拷贝到common.php中
            $new = $Article->where('status=1')->order("cTime desc")->top10();
            $comment = $Comment->where('status=1')->order("id desc")->top8();
            $this->assign("lastArticles", $new);
            $this->assign("lastComments", $comment);

                    // 标签列表
             $List = M("Tag");
             $list  = $List->where("module='Article'")->field('id,name,count')->order('count desc')->limit('0,25')->findAll();
             $this->assign('tags',$list);

                          
                    
             $list = array();
                    // 获取归档文章
             if(!isset($_SESSION["ArticleArchiveList2"])) {
                    $Article = M("Article");
                    $new = $Article->max("cTime");
                    $old = strtotime("-1 year");
                    $time = $new;
                    while($time>=$old) {
                       $list[] = array('year'=>date('Y',$time),'month'=>date('m',$time),'show'=>$time);
                    $time = strtotime('-1 month',$time);
		}
             $_SESSION['ArticleArchiveList2'] = $list;
              }else {
            $list = $_SESSION['ArticleArchiveList2'];
             }
            $this->assign('monthList',$list);
            
		
            $Article = D("ArticleView");
            $count = $Article->where("status=1")->count();
            
            import("@.ORG.Page");
            $p = new Page($count, $listRows);
            $p->setConfig("header", "篇文章");
            $list =  $Article->order("cTime desc")->limit($p->firstRow.','.$p->listRows)->select();
            $page = $p->show();
            $this->assign("list", $list);
            $this->assign("page", $page);

            //统计数据
            $Article = M("Article");
            $stat = array();
            $stat["beginTime"] = $Article->min('cTime');
            $stat["articleCount"] = $Article->where("status=1")->count();
            $stat["readCount"] = $Article->where("status=1")->sum("readCount");
            $stat["commentCount"] = $Article->where("status=1")->sum("commentCount");
            $this->assign($stat);

            $this->display();
	}

        // 获取归档文章
        public function archive() {
            if (checkdate($_REQUEST["month"],'01',$_REQUEST["year"])) {
                $Article = D('ArticleView');
                $begin_time = strtotime($_REQUEST["year"].$_REQUEST["month"]."01");
                $end_time = strtotime("+1 month", $begin_time);
                //$this->assign('title',toDate($begin_time,'Y年m月').' 归档文章');
				import("@.ORG.Page");
                $map = "Article.cTime > $begin_time and Article.cTime < $end_time and Article.status=1";
                $count = $Article->where($map)->count();
				$listRows = 5;
				$p = new Page($count, $listRows);
                $voList  = $Article->where($map)->order('Article.cTime desc')->limit($p->firstRow.','.$p->listRows)->findAll();
                //模板赋值显示
				$page = $p->show();
				$this->assign("page", $page);
				$this->assign('date',$begin_time);
                $this->assign('list',$voList);
				$this->assign("count",$count);
            }
            $this->display();
        }

        public function tag() {
            $Tag = M("Tag");
            if(!empty($_GET['name'])) {
                $name = trim($_REQUEST['name']);
                $list = $Tag->where("module='Article' and name='$name'")->field('id,count')->find();
				$tagId = $list['id'];
				$count = $list['count'];
				import("@.ORG.Page");
				$listRows = 5;
				$fields	= 'a.id,a.userId,a.categoryId,a.cTime,a.readCount,a.commentCount,a.title,c.title as category';
				$p = new Page($count,$listRows);
				$p->setConfig('header' ,'篇文章 ');
				$dao = D("Article");
				$list = $dao->query("select ".$fields." from ".C('DB_PREFIX').'article as a,'.C('DB_PREFIX').'tagged as b, '.C('DB_PREFIX').'category as c where b.tagId  in ('.$tagId.') and a.categoryId= c.id and a.status=1  and a.id=b.recordId order by a.id desc limit '.$p->firstRow.','.$p->listRows);
				if($list) {
                    $page = $p->show();
                    $this->assign("page", $page);
                    $this->assign('list',$list);
                }
                $this->assign('tag',$name);
                $this->assign("count",$count);
            }else {
                $list = $Tag->where("module='Article'")->findAll();
                //dump($list);
                $this->assign('tags',$list);
            }
            $this->display();
        }     

}
?>